(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common')) :
    typeof define === 'function' && define.amd ? define('ngx-scrolltop', ['exports', '@angular/core', '@angular/common'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory(global['ngx-scrolltop'] = {}, global.ng.core, global.ng.common));
}(this, (function (exports, i0, i2) { 'use strict';

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () {
                            return e[k];
                        }
                    });
                }
            });
        }
        n['default'] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);

    var NgxScrollTopCoreService = /** @class */ (function () {
        function NgxScrollTopCoreService(document) {
            this.document = document;
            this.scrolledFromTop = false;
            this.isBrowser = typeof window !== 'undefined';
        }
        NgxScrollTopCoreService.prototype.onWindowScroll = function (mode) {
            var _a, _b;
            var show = false;
            var position = ((_a = this.document.documentElement) === null || _a === void 0 ? void 0 : _a.scrollTop) || ((_b = this.document.scrollingElement) === null || _b === void 0 ? void 0 : _b.scrollTop);
            switch (mode) {
                case 'classic':
                    show = this.classicMode(position);
                    break;
                case 'smart':
                    show = this.smartMode(position);
                    break;
            }
            return show;
        };
        NgxScrollTopCoreService.prototype.classicMode = function (position) {
            var show = false;
            if (this.isBrowser && position > window.innerHeight) {
                show = true;
            }
            else {
                show = false;
            }
            return show;
        };
        NgxScrollTopCoreService.prototype.smartMode = function (position) {
            var show = false;
            if (position === 0) {
                show = false;
                this.scrolledFromTop = false;
            }
            if (this.scrolledFromTop && this.scrollOffset > position) {
                show = true;
            }
            if (this.isBrowser && position > window.innerHeight * 2) {
                this.scrolledFromTop = true;
                this.scrollOffset = position;
            }
            return show;
        };
        NgxScrollTopCoreService.prototype.scrollToTop = function () {
            if (this.isBrowser) {
                window.scroll({ top: 0, left: 0, behavior: 'smooth' });
            }
        };
        return NgxScrollTopCoreService;
    }());
    NgxScrollTopCoreService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopCoreService, deps: [{ token: i2.DOCUMENT }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    NgxScrollTopCoreService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopCoreService });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopCoreService, decorators: [{
                type: i0.Injectable
            }], ctorParameters: function () {
            return [{ type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [i2.DOCUMENT]
                        }] }];
        } });

    var NgxScrollTopComponent = /** @class */ (function () {
        function NgxScrollTopComponent(core) {
            this.core = core;
            this.position = 'right';
            this.theme = 'gray';
            this.mode = 'classic';
            this.show = false;
        }
        NgxScrollTopComponent.prototype.onWindowScroll = function () {
            this.show = this.core.onWindowScroll(this.mode);
        };
        NgxScrollTopComponent.prototype.ngOnChanges = function (changes) {
            // Deprecation warning. It will be removed soon.
            if (changes.symbol) {
                console.error("NgxScrollTop: You are trying to set `" + changes['symbol'].currentValue + "` as your symbol but Input `[symbol]=\"'\u2191'\"` is deprecated now.\n\r", "Use `Content projection` method, like this:\n\r\n\r", "<ngx-scrolltop>" + changes['symbol'].currentValue + "</ngx-scrolltop>\n\r\n\r", "More info: https://github.com/bartholomej/ngx-scrolltop#symbol");
            }
        };
        NgxScrollTopComponent.prototype.scrollToTop = function () {
            this.core.scrollToTop();
        };
        return NgxScrollTopComponent;
    }());
    NgxScrollTopComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopComponent, deps: [{ token: NgxScrollTopCoreService }], target: i0__namespace.ɵɵFactoryTarget.Component });
    NgxScrollTopComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.7", type: NgxScrollTopComponent, selector: "ngx-scrolltop", inputs: { backgroundColor: "backgroundColor", symbolColor: "symbolColor", size: "size", symbol: "symbol", position: "position", theme: "theme", mode: "mode" }, host: { listeners: { "window:scroll": "onWindowScroll()" } }, usesOnChanges: true, ngImport: i0__namespace, template: "<button\n  *ngIf=\"show\"\n  type=\"button\"\n  role=\"button\"\n  aria-label=\"Scroll to top of the page\"\n  tabindex=\"0\"\n  class=\"scrolltop-button\"\n  #scrollTopButton\n  (click)=\"scrollToTop()\"\n  [ngClass]=\"theme\"\n  [style.left]=\"position === 'left' ? '20px' : ''\"\n  [style.backgroundColor]=\"backgroundColor\"\n  [style.width.px]=\"size\"\n  [style.height.px]=\"size\">\n  <div class=\"symbol-container\">\n    <span #ref>\n      <ng-content></ng-content>\n    </span>\n    <svg *ngIf=\"ref.childNodes.length === 0\"\n      aria-hidden=\"true\"\n      [style.fill]=\"symbolColor\"\n      focusable=\"false\"\n      role=\"img\"\n      xmlns=\"http://www.w3.org/2000/svg\"\n      viewBox=\"0 0 448 512\">\n      <path\n        d=\"M240.971 130.524l194.343 194.343c9.373 9.373 9.373 24.569 0 33.941l-22.667 22.667c-9.357 9.357-24.522 9.375-33.901.04L224 227.495 69.255 381.516c-9.379 9.335-24.544 9.317-33.901-.04l-22.667-22.667c-9.373-9.373-9.373-24.569 0-33.941L207.03 130.525c9.372-9.373 24.568-9.373 33.941-.001z\">\n      </path>\n    </svg>\n  </div>\n</button>\n", styles: ["button{outline:0;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.scrolltop-button{position:fixed;display:flex;justify-content:center;align-items:center;border-radius:50%;width:40px;height:40px;right:20px;bottom:20px;cursor:pointer;border:none;transition:opacity .1 linear;z-index:10000;box-shadow:0 5px 5px -3px #0003,0 8px 10px 1px #00000024,0 3px 14px 2px #0000001f}.scrolltop-button:hover{opacity:.92}.scrolltop-button .symbol-container span{font-size:15px}.scrolltop-button .symbol-container svg{transform:translateY(10%);width:50%;vertical-align:baseline}.scrolltop-button.black{background-color:#000;color:#fff}.scrolltop-button.black .symbol-container{color:#fff}.scrolltop-button.black .symbol-container span{color:#fff}.scrolltop-button.black .symbol-container svg{fill:#fff}.scrolltop-button.white{background-color:#fff;color:#000}.scrolltop-button.white .symbol-container{color:#000}.scrolltop-button.white .symbol-container span{color:#000}.scrolltop-button.white .symbol-container svg{fill:#000}.scrolltop-button.gray{background-color:#212121;color:#fafafa}.scrolltop-button.gray .symbol-container{color:#fafafa}.scrolltop-button.gray .symbol-container span{color:#fafafa}.scrolltop-button.gray .symbol-container svg{fill:#fafafa}.scrolltop-button.grey{background-color:#212121;color:#fafafa}.scrolltop-button.grey .symbol-container{color:#fafafa}.scrolltop-button.grey .symbol-container span{color:#fafafa}.scrolltop-button.grey .symbol-container svg{fill:#fafafa}.scrolltop-button.brown{background-color:#3e2723;color:#efebe9}.scrolltop-button.brown .symbol-container{color:#efebe9}.scrolltop-button.brown .symbol-container span{color:#efebe9}.scrolltop-button.brown .symbol-container svg{fill:#efebe9}.scrolltop-button.deeporange{background-color:#bf360c;color:#fbe9e7}.scrolltop-button.deeporange .symbol-container{color:#fbe9e7}.scrolltop-button.deeporange .symbol-container span{color:#fbe9e7}.scrolltop-button.deeporange .symbol-container svg{fill:#fbe9e7}.scrolltop-button.orange{background-color:#ff6d00;color:#fff3e0}.scrolltop-button.orange .symbol-container{color:#fff3e0}.scrolltop-button.orange .symbol-container span{color:#fff3e0}.scrolltop-button.orange .symbol-container svg{fill:#fff3e0}.scrolltop-button.yellow{background-color:#ffd600;color:#fffde7}.scrolltop-button.yellow .symbol-container{color:#fffde7}.scrolltop-button.yellow .symbol-container span{color:#fffde7}.scrolltop-button.yellow .symbol-container svg{fill:#fffde7}.scrolltop-button.green{background-color:#1b5e20;color:#e8f5e9}.scrolltop-button.green .symbol-container{color:#e8f5e9}.scrolltop-button.green .symbol-container span{color:#e8f5e9}.scrolltop-button.green .symbol-container svg{fill:#e8f5e9}.scrolltop-button.blue{background-color:#2962ff;color:#e3f2fd}.scrolltop-button.blue .symbol-container{color:#e3f2fd}.scrolltop-button.blue .symbol-container span{color:#e3f2fd}.scrolltop-button.blue .symbol-container svg{fill:#e3f2fd}.scrolltop-button.purple{background-color:#4a148c;color:#f3e5f5}.scrolltop-button.purple .symbol-container{color:#f3e5f5}.scrolltop-button.purple .symbol-container span{color:#f3e5f5}.scrolltop-button.purple .symbol-container svg{fill:#f3e5f5}.scrolltop-button.deeppurple{background-color:#311b92;color:#ede7f6}.scrolltop-button.deeppurple .symbol-container{color:#ede7f6}.scrolltop-button.deeppurple .symbol-container span{color:#ede7f6}.scrolltop-button.deeppurple .symbol-container svg{fill:#ede7f6}.scrolltop-button.pink{background-color:#880e4f;color:#fce4ec}.scrolltop-button.pink .symbol-container{color:#fce4ec}.scrolltop-button.pink .symbol-container span{color:#fce4ec}.scrolltop-button.pink .symbol-container svg{fill:#fce4ec}.scrolltop-button.red{background-color:#b71c1c;color:#ffebee}.scrolltop-button.red .symbol-container{color:#ffebee}.scrolltop-button.red .symbol-container span{color:#ffebee}.scrolltop-button.red .symbol-container svg{fill:#ffebee}.scrolltop-button.indigo{background-color:#1a237e;color:#e8eaf6}.scrolltop-button.indigo .symbol-container{color:#e8eaf6}.scrolltop-button.indigo .symbol-container span{color:#e8eaf6}.scrolltop-button.indigo .symbol-container svg{fill:#e8eaf6}.scrolltop-button.lightblue{background-color:#01579b;color:#e1f5fe}.scrolltop-button.lightblue .symbol-container{color:#e1f5fe}.scrolltop-button.lightblue .symbol-container span{color:#e1f5fe}.scrolltop-button.lightblue .symbol-container svg{fill:#e1f5fe}.scrolltop-button.cyan{background-color:#006064;color:#e0f7fa}.scrolltop-button.cyan .symbol-container{color:#e0f7fa}.scrolltop-button.cyan .symbol-container span{color:#e0f7fa}.scrolltop-button.cyan .symbol-container svg{fill:#e0f7fa}.scrolltop-button.teal{background-color:#004d40;color:#e0f2f1}.scrolltop-button.teal .symbol-container{color:#e0f2f1}.scrolltop-button.teal .symbol-container span{color:#e0f2f1}.scrolltop-button.teal .symbol-container svg{fill:#e0f2f1}.scrolltop-button.lightgreen{background-color:#33691e;color:#f1f8e9}.scrolltop-button.lightgreen .symbol-container{color:#f1f8e9}.scrolltop-button.lightgreen .symbol-container span{color:#f1f8e9}.scrolltop-button.lightgreen .symbol-container svg{fill:#f1f8e9}.scrolltop-button.lime{background-color:#827717;color:#f9fbe7}.scrolltop-button.lime .symbol-container{color:#f9fbe7}.scrolltop-button.lime .symbol-container span{color:#f9fbe7}.scrolltop-button.lime .symbol-container svg{fill:#f9fbe7}.scrolltop-button.amber{background-color:#ff6f00;color:#fff8e1}.scrolltop-button.amber .symbol-container{color:#fff8e1}.scrolltop-button.amber .symbol-container span{color:#fff8e1}.scrolltop-button.amber .symbol-container svg{fill:#fff8e1}.scrolltop-button.bluegrey{background-color:#263238;color:#eceff1}.scrolltop-button.bluegrey .symbol-container{color:#eceff1}.scrolltop-button.bluegrey .symbol-container span{color:#eceff1}.scrolltop-button.bluegrey .symbol-container svg{fill:#eceff1}\n"], directives: [{ type: i2__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i2__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'ngx-scrolltop',
                        templateUrl: './ngx-scrolltop.component.html',
                        styleUrls: ['./ngx-scrolltop.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: NgxScrollTopCoreService }]; }, propDecorators: { backgroundColor: [{
                    type: i0.Input
                }], symbolColor: [{
                    type: i0.Input
                }], size: [{
                    type: i0.Input
                }], symbol: [{
                    type: i0.Input
                }], position: [{
                    type: i0.Input
                }], theme: [{
                    type: i0.Input
                }], mode: [{
                    type: i0.Input
                }], onWindowScroll: [{
                    type: i0.HostListener,
                    args: ['window:scroll']
                }] } });

    var NgxScrollTopDirective = /** @class */ (function () {
        function NgxScrollTopDirective(el, core) {
            this.el = el;
            this.core = core;
            this.mode = 'classic';
            this.hideElement();
        }
        NgxScrollTopDirective.prototype.onWindowScroll = function () {
            if (this.core.onWindowScroll(this.mode)) {
                this.showElement();
            }
            else {
                this.hideElement();
            }
        };
        NgxScrollTopDirective.prototype.onClick = function () {
            this.scrollToTop();
        };
        NgxScrollTopDirective.prototype.hideElement = function () {
            this.el.nativeElement.style.display = 'none';
        };
        NgxScrollTopDirective.prototype.showElement = function () {
            this.el.nativeElement.style.display = '';
        };
        NgxScrollTopDirective.prototype.scrollToTop = function () {
            this.core.scrollToTop();
        };
        return NgxScrollTopDirective;
    }());
    NgxScrollTopDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopDirective, deps: [{ token: i0__namespace.ElementRef }, { token: NgxScrollTopCoreService }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    NgxScrollTopDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.7", type: NgxScrollTopDirective, selector: "[ngxScrollTop]", inputs: { mode: ["ngxScrollTopMode", "mode"] }, host: { listeners: { "window:scroll": "onWindowScroll()", "click": "onClick()" } }, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[ngxScrollTop]',
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }, { type: NgxScrollTopCoreService }]; }, propDecorators: { mode: [{
                    type: i0.Input,
                    args: ['ngxScrollTopMode']
                }], onWindowScroll: [{
                    type: i0.HostListener,
                    args: ['window:scroll']
                }], onClick: [{
                    type: i0.HostListener,
                    args: ['click']
                }] } });

    var NgxScrollTopModule = /** @class */ (function () {
        function NgxScrollTopModule() {
        }
        return NgxScrollTopModule;
    }());
    NgxScrollTopModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    NgxScrollTopModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopModule, declarations: [NgxScrollTopComponent, NgxScrollTopDirective], imports: [i2.CommonModule], exports: [NgxScrollTopComponent, NgxScrollTopDirective] });
    NgxScrollTopModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopModule, providers: [NgxScrollTopCoreService], imports: [[i2.CommonModule]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.7", ngImport: i0__namespace, type: NgxScrollTopModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [NgxScrollTopComponent, NgxScrollTopDirective],
                        imports: [i2.CommonModule],
                        providers: [NgxScrollTopCoreService],
                        exports: [NgxScrollTopComponent, NgxScrollTopDirective],
                    }]
            }] });

    /*
     * Public API Surface of ngx-scrolltop
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.NgxScrollTopComponent = NgxScrollTopComponent;
    exports.NgxScrollTopDirective = NgxScrollTopDirective;
    exports.NgxScrollTopModule = NgxScrollTopModule;

    Object.defineProperty(exports, '__esModule', { value: true });

})));
//# sourceMappingURL=ngx-scrolltop.umd.js.map
